import{S as wm,i as gm,s as $m,e as a,k as p,w as d,t as i,M as Em,c as n,d as s,m as f,a as o,x as _,h as r,b as h,G as t,g as m,y as v,q as y,o as b,B as w,v as jm}from"../../chunks/vendor-hf-doc-builder.js";import{T as go}from"../../chunks/Tip-hf-doc-builder.js";import{I as N}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as A}from"../../chunks/CodeBlock-hf-doc-builder.js";function km(x){let u;return{c(){u=i("It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},l(c){u=r(c,"It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},m(c,g){m(c,u,g)},d(c){c&&s(u)}}}function Tm(x){let u;return{c(){u=i(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(c){u=r(c,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(c,g){m(c,u,g)},d(c){c&&s(u)}}}function Pm(x){let u,c,g,P;return{c(){u=i("Consider using "),c=a("a"),g=i("model offloading"),P=i(" as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},l($){u=r($,"Consider using "),c=n($,"A",{href:!0});var k=o(c);g=r(k,"model offloading"),k.forEach(s),P=r($," as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},h(){h(c,"href","#model_offloading")},m($,k){m($,u,k),m($,c,k),t(c,g),m($,P,k)},d($){$&&s(u),$&&s(c),$&&s(P)}}}function Dm(x){let u;return{c(){u=i("This feature requires `accelerate` version 0.17.0 or larger.")},l(c){u=r(c,"This feature requires `accelerate` version 0.17.0 or larger.")},m(c,g){m(c,u,g)},d(c){c&&s(u)}}}function Am(x){let u,c,g,P,$,k,$o,ls,Eo,Ra,S,jo,ps,ko,To,Fe,Po,Do,dt,Ao,So,za,_t,qo,Ma,me,fs,R,Ha,No,ms,xo,Uo,hs,Io,Co,j,z,cs,Fo,Go,us,Ro,zo,ds,Mo,Ho,M,_s,Vo,Oo,vs,Bo,Lo,ys,Xo,Yo,H,bs,Wo,Ko,ws,Qo,Jo,gs,Zo,ei,V,$s,ti,si,Es,ai,ni,js,oi,ii,O,ks,ri,li,Ts,pi,fi,Ps,mi,hi,B,Ds,ci,ui,As,di,_i,Ss,vi,Va,vt,yi,Oa,L,he,qs,Ge,bi,Ns,wi,Ba,Re,ze,gi,$i,La,ce,Ei,xs,ji,ki,Xa,Me,Ya,X,ue,Us,He,Ti,Is,Pi,Wa,de,Di,Ve,Ai,Si,Ka,Oe,Qa,Y,_e,Cs,Be,qi,Fs,Ni,Ja,U,xi,Gs,Ui,Ii,Rs,Ci,Fi,Za,Le,en,ve,tn,W,ye,zs,Xe,Gi,Ms,Ri,sn,yt,zi,an,be,nn,we,Mi,bt,Hi,Vi,on,Ye,rn,wt,Oi,ln,K,ge,Hs,We,Bi,Vs,Li,pn,gt,Xi,fn,I,Yi,$t,Wi,Ki,Et,Qi,Ji,mn,$e,Zi,jt,er,tr,hn,Ke,cn,kt,sr,un,Tt,dn,Q,Ee,Os,Qe,ar,Bs,nr,_n,Pt,or,vn,je,ir,Dt,rr,lr,yn,Je,bn,At,pr,wn,ke,fr,Ls,mr,hr,gn,Te,$n,St,cr,En,Ze,jn,D,Xs,ur,dr,Ys,_r,vr,Ws,yr,br,et,wr,gr,kn,qt,Tn,J,Pe,Ks,tt,$r,Qs,Er,Pn,st,Nt,jr,kr,Dn,C,Tr,Js,Pr,Dr,Zs,Ar,Sr,An,xt,qr,Sn,De,Nr,ea,xr,Ur,qn,at,Nn,Ut,Ir,xn,nt,Un,Ae,In,Z,Se,ta,ot,Cr,sa,Fr,Cn,It,Gr,Fn,Ct,Rr,Gn,it,Rn,ee,qe,aa,rt,zr,na,Mr,zn,Ne,Hr,oa,Vr,Or,Mn,Ft,Br,Hn,lt,Vn,xe,Lr,ia,Xr,Yr,On,pt,Bn,te,Ue,ra,ft,Wr,la,Kr,Ln,F,Qr,mt,Jr,Zr,ht,el,tl,Xn,Gt,sl,Yn,Ie,pa,se,fa,al,nl,ma,ol,il,ha,rl,ll,E,ae,ca,pl,fl,ua,ml,hl,da,cl,ul,ne,_a,dl,_l,va,vl,yl,ya,bl,wl,oe,ba,gl,$l,wa,El,jl,ga,kl,Tl,ie,$a,Pl,Dl,Ea,Al,Sl,ja,ql,Nl,re,ka,xl,Ul,Ta,Il,Cl,Pa,Fl,Gl,le,Da,Rl,zl,Aa,Ml,Hl,Sa,Vl,Ol,pe,qa,Bl,Ll,Na,Xl,Yl,xa,Wl,Wn,Rt,Kl,Kn,G,Ua,Ql,Jl,Ia,Zl,ep,zt,Mt,tp,sp,Qn,ct,Jn;return k=new N({}),Ge=new N({}),Me=new A({props:{code:`import torch

torch.backends.cudnn.benchmark = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cudnn.benchmark = <span class="hljs-literal">True</span>`}}),He=new N({}),Oe=new A({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),Be=new N({}),Le=new A({props:{code:`pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ve=new go({props:{warning:!0,$$slots:{default:[km]},$$scope:{ctx:x}}}),Xe=new N({}),be=new go({props:{$$slots:{default:[Tm]},$$scope:{ctx:x}}}),Ye=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),We=new N({}),Ke=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),Qe=new N({}),Je=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Te=new go({props:{$$slots:{default:[Pm]},$$scope:{ctx:x}}}),Ze=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),tt=new N({}),at=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",  
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,  
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),nt=new A({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ae=new go({props:{$$slots:{default:[Dm]},$$scope:{ctx:x}}}),ot=new N({}),it=new A({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),rt=new N({}),lt=new A({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50


# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>


<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),pt=new A({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")


# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)


<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),ft=new N({}),ct=new A({props:{code:`from diffusers import StableDiffusionPipeline
import torch

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){u=a("meta"),c=p(),g=a("h1"),P=a("a"),$=a("span"),d(k.$$.fragment),$o=p(),ls=a("span"),Eo=i("Memory and speed"),Ra=p(),S=a("p"),jo=i("We present some techniques and ideas to optimize \u{1F917} Diffusers "),ps=a("em"),ko=i("inference"),To=i(" for memory or speed. As a general rule, we recommend the use of "),Fe=a("a"),Po=i("xFormers"),Do=i(" for memory efficient attention, please see the recommended "),dt=a("a"),Ao=i("installation instructions"),So=i("."),za=p(),_t=a("p"),qo=i("We\u2019ll discuss how the following settings impact performance and memory."),Ma=p(),me=a("table"),fs=a("thead"),R=a("tr"),Ha=a("th"),No=p(),ms=a("th"),xo=i("Latency"),Uo=p(),hs=a("th"),Io=i("Speedup"),Co=p(),j=a("tbody"),z=a("tr"),cs=a("td"),Fo=i("original"),Go=p(),us=a("td"),Ro=i("9.50s"),zo=p(),ds=a("td"),Mo=i("x1"),Ho=p(),M=a("tr"),_s=a("td"),Vo=i("cuDNN auto-tuner"),Oo=p(),vs=a("td"),Bo=i("9.37s"),Lo=p(),ys=a("td"),Xo=i("x1.01"),Yo=p(),H=a("tr"),bs=a("td"),Wo=i("fp16"),Ko=p(),ws=a("td"),Qo=i("3.61s"),Jo=p(),gs=a("td"),Zo=i("x2.63"),ei=p(),V=a("tr"),$s=a("td"),ti=i("channels last"),si=p(),Es=a("td"),ai=i("3.30s"),ni=p(),js=a("td"),oi=i("x2.88"),ii=p(),O=a("tr"),ks=a("td"),ri=i("traced UNet"),li=p(),Ts=a("td"),pi=i("3.21s"),fi=p(),Ps=a("td"),mi=i("x2.96"),hi=p(),B=a("tr"),Ds=a("td"),ci=i("memory efficient attention"),ui=p(),As=a("td"),di=i("2.63s"),_i=p(),Ss=a("td"),vi=i("x3.61"),Va=p(),vt=a("em"),yi=i(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Oa=p(),L=a("h2"),he=a("a"),qs=a("span"),d(Ge.$$.fragment),bi=p(),Ns=a("span"),wi=i("Enable cuDNN auto-tuner"),Ba=p(),Re=a("p"),ze=a("a"),gi=i("NVIDIA cuDNN"),$i=i("\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),La=p(),ce=a("p"),Ei=i("Since we\u2019re using "),xs=a("strong"),ji=i("convolutional networks"),ki=i(" (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),Xa=p(),d(Me.$$.fragment),Ya=p(),X=a("h3"),ue=a("a"),Us=a("span"),d(He.$$.fragment),Ti=p(),Is=a("span"),Pi=i("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Wa=p(),de=a("p"),Di=i("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ve=a("a"),Ai=i("here"),Si=i(". All you need to do is to add this before your inference:"),Ka=p(),d(Oe.$$.fragment),Qa=p(),Y=a("h2"),_e=a("a"),Cs=a("span"),d(Be.$$.fragment),qi=p(),Fs=a("span"),Ni=i("Half precision weights"),Ja=p(),U=a("p"),xi=i("To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Gs=a("code"),Ui=i("fp16"),Ii=i(", and telling PyTorch to use the "),Rs=a("code"),Ci=i("float16"),Fi=i(" type when loading them:"),Za=p(),d(Le.$$.fragment),en=p(),d(ve.$$.fragment),tn=p(),W=a("h2"),ye=a("a"),zs=a("span"),d(Xe.$$.fragment),Gi=p(),Ms=a("span"),Ri=i("Sliced attention for additional memory savings"),sn=p(),yt=a("p"),zi=i("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),an=p(),d(be.$$.fragment),nn=p(),we=a("p"),Mi=i("To perform the attention computation sequentially over each head, you only need to invoke "),bt=a("a"),Hi=i("enable_attention_slicing()"),Vi=i(" in your pipeline before inference, like here:"),on=p(),d(Ye.$$.fragment),rn=p(),wt=a("p"),Oi=i("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),ln=p(),K=a("h2"),ge=a("a"),Hs=a("span"),d(We.$$.fragment),Bi=p(),Vs=a("span"),Li=i("Sliced VAE decode for larger batches"),pn=p(),gt=a("p"),Xi=i("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),fn=p(),I=a("p"),Yi=i("You likely want to couple this with "),$t=a("a"),Wi=i("enable_attention_slicing()"),Ki=i(" or "),Et=a("a"),Qi=i("enable_xformers_memory_efficient_attention()"),Ji=i(" to further minimize memory use."),mn=p(),$e=a("p"),Zi=i("To perform the VAE decode one image at a time, invoke "),jt=a("a"),er=i("enable_vae_slicing()"),tr=i(" in your pipeline before inference. For example:"),hn=p(),d(Ke.$$.fragment),cn=p(),kt=a("p"),sr=i("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),un=p(),Tt=a("a"),dn=p(),Q=a("h2"),Ee=a("a"),Os=a("span"),d(Qe.$$.fragment),ar=p(),Bs=a("span"),nr=i("Offloading to CPU with accelerate for memory savings"),_n=p(),Pt=a("p"),or=i("For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),vn=p(),je=a("p"),ir=i("To perform CPU offloading, all you have to do is invoke "),Dt=a("a"),rr=i("enable_sequential_cpu_offload()"),lr=i(":"),yn=p(),d(Je.$$.fragment),bn=p(),At=a("p"),pr=i("And you can get the memory consumption to < 3GB."),wn=p(),ke=a("p"),fr=i("Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),Ls=a("code"),mr=i("num_inference_steps"),hr=i("); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),gn=p(),d(Te.$$.fragment),$n=p(),St=a("p"),cr=i("It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),En=p(),d(Ze.$$.fragment),jn=p(),D=a("p"),Xs=a("strong"),ur=i("Note"),dr=i(": When using "),Ys=a("code"),_r=i("enable_sequential_cpu_offload()"),vr=i(", it is important to "),Ws=a("strong"),yr=i("not"),br=i(" move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),et=a("a"),wr=i("this issue"),gr=i(" for more information."),kn=p(),qt=a("a"),Tn=p(),J=a("h2"),Pe=a("a"),Ks=a("span"),d(tt.$$.fragment),$r=p(),Qs=a("span"),Er=i("Model offloading for fast inference and memory savings"),Pn=p(),st=a("p"),Nt=a("a"),jr=i("Sequential CPU offloading"),kr=i(", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),Dn=p(),C=a("p"),Tr=i("Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),Js=a("em"),Pr=i("modules"),Dr=i(". This results in a negligible impact on inference time (compared with moving the pipeline to "),Zs=a("code"),Ar=i("cuda"),Sr=i("), while still providing some memory savings."),An=p(),xt=a("p"),qr=i(`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Compoments like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),Sn=p(),De=a("p"),Nr=i("This feature can be enabled by invoking "),ea=a("code"),xr=i("enable_model_cpu_offload()"),Ur=i(" on the pipeline, as shown below."),qn=p(),d(at.$$.fragment),Nn=p(),Ut=a("p"),Ir=i("This is also compatible with attention slicing for additional memory savings."),xn=p(),d(nt.$$.fragment),Un=p(),d(Ae.$$.fragment),In=p(),Z=a("h2"),Se=a("a"),ta=a("span"),d(ot.$$.fragment),Cr=p(),sa=a("span"),Fr=i("Using Channels Last memory format"),Cn=p(),It=a("p"),Gr=i("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),Fn=p(),Ct=a("p"),Rr=i("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),Gn=p(),d(it.$$.fragment),Rn=p(),ee=a("h2"),qe=a("a"),aa=a("span"),d(rt.$$.fragment),zr=p(),na=a("span"),Mr=i("Tracing"),zn=p(),Ne=a("p"),Hr=i("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),oa=a("code"),Vr=i("ScriptFunction"),Or=i(" is returned that will be optimized using just-in-time compilation."),Mn=p(),Ft=a("p"),Br=i("To trace our UNet model, we can use the following:"),Hn=p(),d(lt.$$.fragment),Vn=p(),xe=a("p"),Lr=i("Then we can replace the "),ia=a("code"),Xr=i("unet"),Yr=i(" attribute of the pipeline with the traced model like the following"),On=p(),d(pt.$$.fragment),Bn=p(),te=a("h2"),Ue=a("a"),ra=a("span"),d(ft.$$.fragment),Wr=p(),la=a("span"),Kr=i("Memory Efficient Attention"),Ln=p(),F=a("p"),Qr=i("Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),mt=a("a"),Jr=i("code"),Zr=i(", "),ht=a("a"),el=i("paper"),tl=i("."),Xn=p(),Gt=a("p"),sl=i("Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),Yn=p(),Ie=a("table"),pa=a("thead"),se=a("tr"),fa=a("th"),al=i("GPU"),nl=p(),ma=a("th"),ol=i("Base Attention FP16"),il=p(),ha=a("th"),rl=i("Memory Efficient Attention FP16"),ll=p(),E=a("tbody"),ae=a("tr"),ca=a("td"),pl=i("NVIDIA Tesla T4"),fl=p(),ua=a("td"),ml=i("3.5it/s"),hl=p(),da=a("td"),cl=i("5.5it/s"),ul=p(),ne=a("tr"),_a=a("td"),dl=i("NVIDIA 3060 RTX"),_l=p(),va=a("td"),vl=i("4.6it/s"),yl=p(),ya=a("td"),bl=i("7.8it/s"),wl=p(),oe=a("tr"),ba=a("td"),gl=i("NVIDIA A10G"),$l=p(),wa=a("td"),El=i("8.88it/s"),jl=p(),ga=a("td"),kl=i("15.6it/s"),Tl=p(),ie=a("tr"),$a=a("td"),Pl=i("NVIDIA RTX A6000"),Dl=p(),Ea=a("td"),Al=i("11.7it/s"),Sl=p(),ja=a("td"),ql=i("21.09it/s"),Nl=p(),re=a("tr"),ka=a("td"),xl=i("NVIDIA TITAN RTX"),Ul=p(),Ta=a("td"),Il=i("12.51it/s"),Cl=p(),Pa=a("td"),Fl=i("18.22it/s"),Gl=p(),le=a("tr"),Da=a("td"),Rl=i("A100-SXM4-40GB"),zl=p(),Aa=a("td"),Ml=i("18.6it/s"),Hl=p(),Sa=a("td"),Vl=i("29.it/s"),Ol=p(),pe=a("tr"),qa=a("td"),Bl=i("A100-SXM-80GB"),Ll=p(),Na=a("td"),Xl=i("18.7it/s"),Yl=p(),xa=a("td"),Wl=i("29.5it/s"),Wn=p(),Rt=a("p"),Kl=i("To leverage it just make sure you have:"),Kn=p(),G=a("ul"),Ua=a("li"),Ql=i("PyTorch > 1.12"),Jl=p(),Ia=a("li"),Zl=i("Cuda available"),ep=p(),zt=a("li"),Mt=a("a"),tp=i("Installed the xformers library"),sp=i("."),Qn=p(),d(ct.$$.fragment),this.h()},l(e){const l=Em('[data-svelte="svelte-1phssyn"]',document.head);u=n(l,"META",{name:!0,content:!0}),l.forEach(s),c=f(e),g=n(e,"H1",{class:!0});var ut=o(g);P=n(ut,"A",{id:!0,class:!0,href:!0});var Ca=o(P);$=n(Ca,"SPAN",{});var Fa=o($);_(k.$$.fragment,Fa),Fa.forEach(s),Ca.forEach(s),$o=f(ut),ls=n(ut,"SPAN",{});var Ga=o(ls);Eo=r(Ga,"Memory and speed"),Ga.forEach(s),ut.forEach(s),Ra=f(e),S=n(e,"P",{});var Ce=o(S);jo=r(Ce,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),ps=n(Ce,"EM",{});var ip=o(ps);ko=r(ip,"inference"),ip.forEach(s),To=r(Ce," for memory or speed. As a general rule, we recommend the use of "),Fe=n(Ce,"A",{href:!0,rel:!0});var rp=o(Fe);Po=r(rp,"xFormers"),rp.forEach(s),Do=r(Ce," for memory efficient attention, please see the recommended "),dt=n(Ce,"A",{href:!0});var lp=o(dt);Ao=r(lp,"installation instructions"),lp.forEach(s),So=r(Ce,"."),Ce.forEach(s),za=f(e),_t=n(e,"P",{});var pp=o(_t);qo=r(pp,"We\u2019ll discuss how the following settings impact performance and memory."),pp.forEach(s),Ma=f(e),me=n(e,"TABLE",{});var Zn=o(me);fs=n(Zn,"THEAD",{});var fp=o(fs);R=n(fp,"TR",{});var Ht=o(R);Ha=n(Ht,"TH",{}),o(Ha).forEach(s),No=f(Ht),ms=n(Ht,"TH",{});var mp=o(ms);xo=r(mp,"Latency"),mp.forEach(s),Uo=f(Ht),hs=n(Ht,"TH",{});var hp=o(hs);Io=r(hp,"Speedup"),hp.forEach(s),Ht.forEach(s),fp.forEach(s),Co=f(Zn),j=n(Zn,"TBODY",{});var q=o(j);z=n(q,"TR",{});var Vt=o(z);cs=n(Vt,"TD",{});var cp=o(cs);Fo=r(cp,"original"),cp.forEach(s),Go=f(Vt),us=n(Vt,"TD",{});var up=o(us);Ro=r(up,"9.50s"),up.forEach(s),zo=f(Vt),ds=n(Vt,"TD",{});var dp=o(ds);Mo=r(dp,"x1"),dp.forEach(s),Vt.forEach(s),Ho=f(q),M=n(q,"TR",{});var Ot=o(M);_s=n(Ot,"TD",{});var _p=o(_s);Vo=r(_p,"cuDNN auto-tuner"),_p.forEach(s),Oo=f(Ot),vs=n(Ot,"TD",{});var vp=o(vs);Bo=r(vp,"9.37s"),vp.forEach(s),Lo=f(Ot),ys=n(Ot,"TD",{});var yp=o(ys);Xo=r(yp,"x1.01"),yp.forEach(s),Ot.forEach(s),Yo=f(q),H=n(q,"TR",{});var Bt=o(H);bs=n(Bt,"TD",{});var bp=o(bs);Wo=r(bp,"fp16"),bp.forEach(s),Ko=f(Bt),ws=n(Bt,"TD",{});var wp=o(ws);Qo=r(wp,"3.61s"),wp.forEach(s),Jo=f(Bt),gs=n(Bt,"TD",{});var gp=o(gs);Zo=r(gp,"x2.63"),gp.forEach(s),Bt.forEach(s),ei=f(q),V=n(q,"TR",{});var Lt=o(V);$s=n(Lt,"TD",{});var $p=o($s);ti=r($p,"channels last"),$p.forEach(s),si=f(Lt),Es=n(Lt,"TD",{});var Ep=o(Es);ai=r(Ep,"3.30s"),Ep.forEach(s),ni=f(Lt),js=n(Lt,"TD",{});var jp=o(js);oi=r(jp,"x2.88"),jp.forEach(s),Lt.forEach(s),ii=f(q),O=n(q,"TR",{});var Xt=o(O);ks=n(Xt,"TD",{});var kp=o(ks);ri=r(kp,"traced UNet"),kp.forEach(s),li=f(Xt),Ts=n(Xt,"TD",{});var Tp=o(Ts);pi=r(Tp,"3.21s"),Tp.forEach(s),fi=f(Xt),Ps=n(Xt,"TD",{});var Pp=o(Ps);mi=r(Pp,"x2.96"),Pp.forEach(s),Xt.forEach(s),hi=f(q),B=n(q,"TR",{});var Yt=o(B);Ds=n(Yt,"TD",{});var Dp=o(Ds);ci=r(Dp,"memory efficient attention"),Dp.forEach(s),ui=f(Yt),As=n(Yt,"TD",{});var Ap=o(As);di=r(Ap,"2.63s"),Ap.forEach(s),_i=f(Yt),Ss=n(Yt,"TD",{});var Sp=o(Ss);vi=r(Sp,"x3.61"),Sp.forEach(s),Yt.forEach(s),q.forEach(s),Zn.forEach(s),Va=f(e),vt=n(e,"EM",{});var qp=o(vt);yi=r(qp,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),qp.forEach(s),Oa=f(e),L=n(e,"H2",{class:!0});var eo=o(L);he=n(eo,"A",{id:!0,class:!0,href:!0});var Np=o(he);qs=n(Np,"SPAN",{});var xp=o(qs);_(Ge.$$.fragment,xp),xp.forEach(s),Np.forEach(s),bi=f(eo),Ns=n(eo,"SPAN",{});var Up=o(Ns);wi=r(Up,"Enable cuDNN auto-tuner"),Up.forEach(s),eo.forEach(s),Ba=f(e),Re=n(e,"P",{});var ap=o(Re);ze=n(ap,"A",{href:!0,rel:!0});var Ip=o(ze);gi=r(Ip,"NVIDIA cuDNN"),Ip.forEach(s),$i=r(ap,"\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),ap.forEach(s),La=f(e),ce=n(e,"P",{});var to=o(ce);Ei=r(to,"Since we\u2019re using "),xs=n(to,"STRONG",{});var Cp=o(xs);ji=r(Cp,"convolutional networks"),Cp.forEach(s),ki=r(to," (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),to.forEach(s),Xa=f(e),_(Me.$$.fragment,e),Ya=f(e),X=n(e,"H3",{class:!0});var so=o(X);ue=n(so,"A",{id:!0,class:!0,href:!0});var Fp=o(ue);Us=n(Fp,"SPAN",{});var Gp=o(Us);_(He.$$.fragment,Gp),Gp.forEach(s),Fp.forEach(s),Ti=f(so),Is=n(so,"SPAN",{});var Rp=o(Is);Pi=r(Rp,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Rp.forEach(s),so.forEach(s),Wa=f(e),de=n(e,"P",{});var ao=o(de);Di=r(ao,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ve=n(ao,"A",{href:!0,rel:!0});var zp=o(Ve);Ai=r(zp,"here"),zp.forEach(s),Si=r(ao,". All you need to do is to add this before your inference:"),ao.forEach(s),Ka=f(e),_(Oe.$$.fragment,e),Qa=f(e),Y=n(e,"H2",{class:!0});var no=o(Y);_e=n(no,"A",{id:!0,class:!0,href:!0});var Mp=o(_e);Cs=n(Mp,"SPAN",{});var Hp=o(Cs);_(Be.$$.fragment,Hp),Hp.forEach(s),Mp.forEach(s),qi=f(no),Fs=n(no,"SPAN",{});var Vp=o(Fs);Ni=r(Vp,"Half precision weights"),Vp.forEach(s),no.forEach(s),Ja=f(e),U=n(e,"P",{});var Wt=o(U);xi=r(Wt,"To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Gs=n(Wt,"CODE",{});var Op=o(Gs);Ui=r(Op,"fp16"),Op.forEach(s),Ii=r(Wt,", and telling PyTorch to use the "),Rs=n(Wt,"CODE",{});var Bp=o(Rs);Ci=r(Bp,"float16"),Bp.forEach(s),Fi=r(Wt," type when loading them:"),Wt.forEach(s),Za=f(e),_(Le.$$.fragment,e),en=f(e),_(ve.$$.fragment,e),tn=f(e),W=n(e,"H2",{class:!0});var oo=o(W);ye=n(oo,"A",{id:!0,class:!0,href:!0});var Lp=o(ye);zs=n(Lp,"SPAN",{});var Xp=o(zs);_(Xe.$$.fragment,Xp),Xp.forEach(s),Lp.forEach(s),Gi=f(oo),Ms=n(oo,"SPAN",{});var Yp=o(Ms);Ri=r(Yp,"Sliced attention for additional memory savings"),Yp.forEach(s),oo.forEach(s),sn=f(e),yt=n(e,"P",{});var Wp=o(yt);zi=r(Wp,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Wp.forEach(s),an=f(e),_(be.$$.fragment,e),nn=f(e),we=n(e,"P",{});var io=o(we);Mi=r(io,"To perform the attention computation sequentially over each head, you only need to invoke "),bt=n(io,"A",{href:!0});var Kp=o(bt);Hi=r(Kp,"enable_attention_slicing()"),Kp.forEach(s),Vi=r(io," in your pipeline before inference, like here:"),io.forEach(s),on=f(e),_(Ye.$$.fragment,e),rn=f(e),wt=n(e,"P",{});var Qp=o(wt);Oi=r(Qp,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),Qp.forEach(s),ln=f(e),K=n(e,"H2",{class:!0});var ro=o(K);ge=n(ro,"A",{id:!0,class:!0,href:!0});var Jp=o(ge);Hs=n(Jp,"SPAN",{});var Zp=o(Hs);_(We.$$.fragment,Zp),Zp.forEach(s),Jp.forEach(s),Bi=f(ro),Vs=n(ro,"SPAN",{});var ef=o(Vs);Li=r(ef,"Sliced VAE decode for larger batches"),ef.forEach(s),ro.forEach(s),pn=f(e),gt=n(e,"P",{});var tf=o(gt);Xi=r(tf,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),tf.forEach(s),fn=f(e),I=n(e,"P",{});var Kt=o(I);Yi=r(Kt,"You likely want to couple this with "),$t=n(Kt,"A",{href:!0});var sf=o($t);Wi=r(sf,"enable_attention_slicing()"),sf.forEach(s),Ki=r(Kt," or "),Et=n(Kt,"A",{href:!0});var af=o(Et);Qi=r(af,"enable_xformers_memory_efficient_attention()"),af.forEach(s),Ji=r(Kt," to further minimize memory use."),Kt.forEach(s),mn=f(e),$e=n(e,"P",{});var lo=o($e);Zi=r(lo,"To perform the VAE decode one image at a time, invoke "),jt=n(lo,"A",{href:!0});var nf=o(jt);er=r(nf,"enable_vae_slicing()"),nf.forEach(s),tr=r(lo," in your pipeline before inference. For example:"),lo.forEach(s),hn=f(e),_(Ke.$$.fragment,e),cn=f(e),kt=n(e,"P",{});var of=o(kt);sr=r(of,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),of.forEach(s),un=f(e),Tt=n(e,"A",{name:!0}),o(Tt).forEach(s),dn=f(e),Q=n(e,"H2",{class:!0});var po=o(Q);Ee=n(po,"A",{id:!0,class:!0,href:!0});var rf=o(Ee);Os=n(rf,"SPAN",{});var lf=o(Os);_(Qe.$$.fragment,lf),lf.forEach(s),rf.forEach(s),ar=f(po),Bs=n(po,"SPAN",{});var pf=o(Bs);nr=r(pf,"Offloading to CPU with accelerate for memory savings"),pf.forEach(s),po.forEach(s),_n=f(e),Pt=n(e,"P",{});var ff=o(Pt);or=r(ff,"For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),ff.forEach(s),vn=f(e),je=n(e,"P",{});var fo=o(je);ir=r(fo,"To perform CPU offloading, all you have to do is invoke "),Dt=n(fo,"A",{href:!0});var mf=o(Dt);rr=r(mf,"enable_sequential_cpu_offload()"),mf.forEach(s),lr=r(fo,":"),fo.forEach(s),yn=f(e),_(Je.$$.fragment,e),bn=f(e),At=n(e,"P",{});var hf=o(At);pr=r(hf,"And you can get the memory consumption to < 3GB."),hf.forEach(s),wn=f(e),ke=n(e,"P",{});var mo=o(ke);fr=r(mo,"Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),Ls=n(mo,"CODE",{});var cf=o(Ls);mr=r(cf,"num_inference_steps"),cf.forEach(s),hr=r(mo,"); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),mo.forEach(s),gn=f(e),_(Te.$$.fragment,e),$n=f(e),St=n(e,"P",{});var uf=o(St);cr=r(uf,"It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),uf.forEach(s),En=f(e),_(Ze.$$.fragment,e),jn=f(e),D=n(e,"P",{});var fe=o(D);Xs=n(fe,"STRONG",{});var df=o(Xs);ur=r(df,"Note"),df.forEach(s),dr=r(fe,": When using "),Ys=n(fe,"CODE",{});var _f=o(Ys);_r=r(_f,"enable_sequential_cpu_offload()"),_f.forEach(s),vr=r(fe,", it is important to "),Ws=n(fe,"STRONG",{});var vf=o(Ws);yr=r(vf,"not"),vf.forEach(s),br=r(fe," move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),et=n(fe,"A",{href:!0,rel:!0});var yf=o(et);wr=r(yf,"this issue"),yf.forEach(s),gr=r(fe," for more information."),fe.forEach(s),kn=f(e),qt=n(e,"A",{name:!0}),o(qt).forEach(s),Tn=f(e),J=n(e,"H2",{class:!0});var ho=o(J);Pe=n(ho,"A",{id:!0,class:!0,href:!0});var bf=o(Pe);Ks=n(bf,"SPAN",{});var wf=o(Ks);_(tt.$$.fragment,wf),wf.forEach(s),bf.forEach(s),$r=f(ho),Qs=n(ho,"SPAN",{});var gf=o(Qs);Er=r(gf,"Model offloading for fast inference and memory savings"),gf.forEach(s),ho.forEach(s),Pn=f(e),st=n(e,"P",{});var np=o(st);Nt=n(np,"A",{href:!0});var $f=o(Nt);jr=r($f,"Sequential CPU offloading"),$f.forEach(s),kr=r(np,", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),np.forEach(s),Dn=f(e),C=n(e,"P",{});var Qt=o(C);Tr=r(Qt,"Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),Js=n(Qt,"EM",{});var Ef=o(Js);Pr=r(Ef,"modules"),Ef.forEach(s),Dr=r(Qt,". This results in a negligible impact on inference time (compared with moving the pipeline to "),Zs=n(Qt,"CODE",{});var jf=o(Zs);Ar=r(jf,"cuda"),jf.forEach(s),Sr=r(Qt,"), while still providing some memory savings."),Qt.forEach(s),An=f(e),xt=n(e,"P",{});var kf=o(xt);qr=r(kf,`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Compoments like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),kf.forEach(s),Sn=f(e),De=n(e,"P",{});var co=o(De);Nr=r(co,"This feature can be enabled by invoking "),ea=n(co,"CODE",{});var Tf=o(ea);xr=r(Tf,"enable_model_cpu_offload()"),Tf.forEach(s),Ur=r(co," on the pipeline, as shown below."),co.forEach(s),qn=f(e),_(at.$$.fragment,e),Nn=f(e),Ut=n(e,"P",{});var Pf=o(Ut);Ir=r(Pf,"This is also compatible with attention slicing for additional memory savings."),Pf.forEach(s),xn=f(e),_(nt.$$.fragment,e),Un=f(e),_(Ae.$$.fragment,e),In=f(e),Z=n(e,"H2",{class:!0});var uo=o(Z);Se=n(uo,"A",{id:!0,class:!0,href:!0});var Df=o(Se);ta=n(Df,"SPAN",{});var Af=o(ta);_(ot.$$.fragment,Af),Af.forEach(s),Df.forEach(s),Cr=f(uo),sa=n(uo,"SPAN",{});var Sf=o(sa);Fr=r(Sf,"Using Channels Last memory format"),Sf.forEach(s),uo.forEach(s),Cn=f(e),It=n(e,"P",{});var qf=o(It);Gr=r(qf,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),qf.forEach(s),Fn=f(e),Ct=n(e,"P",{});var Nf=o(Ct);Rr=r(Nf,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),Nf.forEach(s),Gn=f(e),_(it.$$.fragment,e),Rn=f(e),ee=n(e,"H2",{class:!0});var _o=o(ee);qe=n(_o,"A",{id:!0,class:!0,href:!0});var xf=o(qe);aa=n(xf,"SPAN",{});var Uf=o(aa);_(rt.$$.fragment,Uf),Uf.forEach(s),xf.forEach(s),zr=f(_o),na=n(_o,"SPAN",{});var If=o(na);Mr=r(If,"Tracing"),If.forEach(s),_o.forEach(s),zn=f(e),Ne=n(e,"P",{});var vo=o(Ne);Hr=r(vo,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),oa=n(vo,"CODE",{});var Cf=o(oa);Vr=r(Cf,"ScriptFunction"),Cf.forEach(s),Or=r(vo," is returned that will be optimized using just-in-time compilation."),vo.forEach(s),Mn=f(e),Ft=n(e,"P",{});var Ff=o(Ft);Br=r(Ff,"To trace our UNet model, we can use the following:"),Ff.forEach(s),Hn=f(e),_(lt.$$.fragment,e),Vn=f(e),xe=n(e,"P",{});var yo=o(xe);Lr=r(yo,"Then we can replace the "),ia=n(yo,"CODE",{});var Gf=o(ia);Xr=r(Gf,"unet"),Gf.forEach(s),Yr=r(yo," attribute of the pipeline with the traced model like the following"),yo.forEach(s),On=f(e),_(pt.$$.fragment,e),Bn=f(e),te=n(e,"H2",{class:!0});var bo=o(te);Ue=n(bo,"A",{id:!0,class:!0,href:!0});var Rf=o(Ue);ra=n(Rf,"SPAN",{});var zf=o(ra);_(ft.$$.fragment,zf),zf.forEach(s),Rf.forEach(s),Wr=f(bo),la=n(bo,"SPAN",{});var Mf=o(la);Kr=r(Mf,"Memory Efficient Attention"),Mf.forEach(s),bo.forEach(s),Ln=f(e),F=n(e,"P",{});var Jt=o(F);Qr=r(Jt,"Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),mt=n(Jt,"A",{href:!0,rel:!0});var Hf=o(mt);Jr=r(Hf,"code"),Hf.forEach(s),Zr=r(Jt,", "),ht=n(Jt,"A",{href:!0,rel:!0});var Vf=o(ht);el=r(Vf,"paper"),Vf.forEach(s),tl=r(Jt,"."),Jt.forEach(s),Xn=f(e),Gt=n(e,"P",{});var Of=o(Gt);sl=r(Of,"Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),Of.forEach(s),Yn=f(e),Ie=n(e,"TABLE",{});var wo=o(Ie);pa=n(wo,"THEAD",{});var Bf=o(pa);se=n(Bf,"TR",{});var Zt=o(se);fa=n(Zt,"TH",{});var Lf=o(fa);al=r(Lf,"GPU"),Lf.forEach(s),nl=f(Zt),ma=n(Zt,"TH",{});var Xf=o(ma);ol=r(Xf,"Base Attention FP16"),Xf.forEach(s),il=f(Zt),ha=n(Zt,"TH",{});var Yf=o(ha);rl=r(Yf,"Memory Efficient Attention FP16"),Yf.forEach(s),Zt.forEach(s),Bf.forEach(s),ll=f(wo),E=n(wo,"TBODY",{});var T=o(E);ae=n(T,"TR",{});var es=o(ae);ca=n(es,"TD",{});var Wf=o(ca);pl=r(Wf,"NVIDIA Tesla T4"),Wf.forEach(s),fl=f(es),ua=n(es,"TD",{});var Kf=o(ua);ml=r(Kf,"3.5it/s"),Kf.forEach(s),hl=f(es),da=n(es,"TD",{});var Qf=o(da);cl=r(Qf,"5.5it/s"),Qf.forEach(s),es.forEach(s),ul=f(T),ne=n(T,"TR",{});var ts=o(ne);_a=n(ts,"TD",{});var Jf=o(_a);dl=r(Jf,"NVIDIA 3060 RTX"),Jf.forEach(s),_l=f(ts),va=n(ts,"TD",{});var Zf=o(va);vl=r(Zf,"4.6it/s"),Zf.forEach(s),yl=f(ts),ya=n(ts,"TD",{});var em=o(ya);bl=r(em,"7.8it/s"),em.forEach(s),ts.forEach(s),wl=f(T),oe=n(T,"TR",{});var ss=o(oe);ba=n(ss,"TD",{});var tm=o(ba);gl=r(tm,"NVIDIA A10G"),tm.forEach(s),$l=f(ss),wa=n(ss,"TD",{});var sm=o(wa);El=r(sm,"8.88it/s"),sm.forEach(s),jl=f(ss),ga=n(ss,"TD",{});var am=o(ga);kl=r(am,"15.6it/s"),am.forEach(s),ss.forEach(s),Tl=f(T),ie=n(T,"TR",{});var as=o(ie);$a=n(as,"TD",{});var nm=o($a);Pl=r(nm,"NVIDIA RTX A6000"),nm.forEach(s),Dl=f(as),Ea=n(as,"TD",{});var om=o(Ea);Al=r(om,"11.7it/s"),om.forEach(s),Sl=f(as),ja=n(as,"TD",{});var im=o(ja);ql=r(im,"21.09it/s"),im.forEach(s),as.forEach(s),Nl=f(T),re=n(T,"TR",{});var ns=o(re);ka=n(ns,"TD",{});var rm=o(ka);xl=r(rm,"NVIDIA TITAN RTX"),rm.forEach(s),Ul=f(ns),Ta=n(ns,"TD",{});var lm=o(Ta);Il=r(lm,"12.51it/s"),lm.forEach(s),Cl=f(ns),Pa=n(ns,"TD",{});var pm=o(Pa);Fl=r(pm,"18.22it/s"),pm.forEach(s),ns.forEach(s),Gl=f(T),le=n(T,"TR",{});var os=o(le);Da=n(os,"TD",{});var fm=o(Da);Rl=r(fm,"A100-SXM4-40GB"),fm.forEach(s),zl=f(os),Aa=n(os,"TD",{});var mm=o(Aa);Ml=r(mm,"18.6it/s"),mm.forEach(s),Hl=f(os),Sa=n(os,"TD",{});var hm=o(Sa);Vl=r(hm,"29.it/s"),hm.forEach(s),os.forEach(s),Ol=f(T),pe=n(T,"TR",{});var is=o(pe);qa=n(is,"TD",{});var cm=o(qa);Bl=r(cm,"A100-SXM-80GB"),cm.forEach(s),Ll=f(is),Na=n(is,"TD",{});var um=o(Na);Xl=r(um,"18.7it/s"),um.forEach(s),Yl=f(is),xa=n(is,"TD",{});var dm=o(xa);Wl=r(dm,"29.5it/s"),dm.forEach(s),is.forEach(s),T.forEach(s),wo.forEach(s),Wn=f(e),Rt=n(e,"P",{});var _m=o(Rt);Kl=r(_m,"To leverage it just make sure you have:"),_m.forEach(s),Kn=f(e),G=n(e,"UL",{});var rs=o(G);Ua=n(rs,"LI",{});var vm=o(Ua);Ql=r(vm,"PyTorch > 1.12"),vm.forEach(s),Jl=f(rs),Ia=n(rs,"LI",{});var ym=o(Ia);Zl=r(ym,"Cuda available"),ym.forEach(s),ep=f(rs),zt=n(rs,"LI",{});var op=o(zt);Mt=n(op,"A",{href:!0});var bm=o(Mt);tp=r(bm,"Installed the xformers library"),bm.forEach(s),sp=r(op,"."),op.forEach(s),rs.forEach(s),Qn=f(e),_(ct.$$.fragment,e),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",JSON.stringify(Sm)),h(P,"id","memory-and-speed"),h(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(P,"href","#memory-and-speed"),h(g,"class","relative group"),h(Fe,"href","https://github.com/facebookresearch/xformers"),h(Fe,"rel","nofollow"),h(dt,"href","xformers"),h(he,"id","enable-cudnn-autotuner"),h(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(he,"href","#enable-cudnn-autotuner"),h(L,"class","relative group"),h(ze,"href","https://developer.nvidia.com/cudnn"),h(ze,"rel","nofollow"),h(ue,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ue,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(X,"class","relative group"),h(Ve,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Ve,"rel","nofollow"),h(_e,"id","half-precision-weights"),h(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(_e,"href","#half-precision-weights"),h(Y,"class","relative group"),h(ye,"id","sliced-attention-for-additional-memory-savings"),h(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ye,"href","#sliced-attention-for-additional-memory-savings"),h(W,"class","relative group"),h(bt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.enable_attention_slicing"),h(ge,"id","sliced-vae-decode-for-larger-batches"),h(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ge,"href","#sliced-vae-decode-for-larger-batches"),h(K,"class","relative group"),h($t,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.enable_attention_slicing"),h(Et,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.enable_xformers_memory_efficient_attention"),h(jt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(Tt,"name","sequential_offloading"),h(Ee,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ee,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(Q,"class","relative group"),h(Dt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload"),h(et,"href","https://github.com/huggingface/diffusers/issues/1934"),h(et,"rel","nofollow"),h(qt,"name","model_offloading"),h(Pe,"id","model-offloading-for-fast-inference-and-memory-savings"),h(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Pe,"href","#model-offloading-for-fast-inference-and-memory-savings"),h(J,"class","relative group"),h(Nt,"href","#sequential_offloading"),h(Se,"id","using-channels-last-memory-format"),h(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Se,"href","#using-channels-last-memory-format"),h(Z,"class","relative group"),h(qe,"id","tracing"),h(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(qe,"href","#tracing"),h(ee,"class","relative group"),h(Ue,"id","memory-efficient-attention"),h(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ue,"href","#memory-efficient-attention"),h(te,"class","relative group"),h(mt,"href","https://github.com/HazyResearch/flash-attention"),h(mt,"rel","nofollow"),h(ht,"href","https://arxiv.org/pdf/2205.14135.pdf"),h(ht,"rel","nofollow"),h(Mt,"href","xformers")},m(e,l){t(document.head,u),m(e,c,l),m(e,g,l),t(g,P),t(P,$),v(k,$,null),t(g,$o),t(g,ls),t(ls,Eo),m(e,Ra,l),m(e,S,l),t(S,jo),t(S,ps),t(ps,ko),t(S,To),t(S,Fe),t(Fe,Po),t(S,Do),t(S,dt),t(dt,Ao),t(S,So),m(e,za,l),m(e,_t,l),t(_t,qo),m(e,Ma,l),m(e,me,l),t(me,fs),t(fs,R),t(R,Ha),t(R,No),t(R,ms),t(ms,xo),t(R,Uo),t(R,hs),t(hs,Io),t(me,Co),t(me,j),t(j,z),t(z,cs),t(cs,Fo),t(z,Go),t(z,us),t(us,Ro),t(z,zo),t(z,ds),t(ds,Mo),t(j,Ho),t(j,M),t(M,_s),t(_s,Vo),t(M,Oo),t(M,vs),t(vs,Bo),t(M,Lo),t(M,ys),t(ys,Xo),t(j,Yo),t(j,H),t(H,bs),t(bs,Wo),t(H,Ko),t(H,ws),t(ws,Qo),t(H,Jo),t(H,gs),t(gs,Zo),t(j,ei),t(j,V),t(V,$s),t($s,ti),t(V,si),t(V,Es),t(Es,ai),t(V,ni),t(V,js),t(js,oi),t(j,ii),t(j,O),t(O,ks),t(ks,ri),t(O,li),t(O,Ts),t(Ts,pi),t(O,fi),t(O,Ps),t(Ps,mi),t(j,hi),t(j,B),t(B,Ds),t(Ds,ci),t(B,ui),t(B,As),t(As,di),t(B,_i),t(B,Ss),t(Ss,vi),m(e,Va,l),m(e,vt,l),t(vt,yi),m(e,Oa,l),m(e,L,l),t(L,he),t(he,qs),v(Ge,qs,null),t(L,bi),t(L,Ns),t(Ns,wi),m(e,Ba,l),m(e,Re,l),t(Re,ze),t(ze,gi),t(Re,$i),m(e,La,l),m(e,ce,l),t(ce,Ei),t(ce,xs),t(xs,ji),t(ce,ki),m(e,Xa,l),v(Me,e,l),m(e,Ya,l),m(e,X,l),t(X,ue),t(ue,Us),v(He,Us,null),t(X,Ti),t(X,Is),t(Is,Pi),m(e,Wa,l),m(e,de,l),t(de,Di),t(de,Ve),t(Ve,Ai),t(de,Si),m(e,Ka,l),v(Oe,e,l),m(e,Qa,l),m(e,Y,l),t(Y,_e),t(_e,Cs),v(Be,Cs,null),t(Y,qi),t(Y,Fs),t(Fs,Ni),m(e,Ja,l),m(e,U,l),t(U,xi),t(U,Gs),t(Gs,Ui),t(U,Ii),t(U,Rs),t(Rs,Ci),t(U,Fi),m(e,Za,l),v(Le,e,l),m(e,en,l),v(ve,e,l),m(e,tn,l),m(e,W,l),t(W,ye),t(ye,zs),v(Xe,zs,null),t(W,Gi),t(W,Ms),t(Ms,Ri),m(e,sn,l),m(e,yt,l),t(yt,zi),m(e,an,l),v(be,e,l),m(e,nn,l),m(e,we,l),t(we,Mi),t(we,bt),t(bt,Hi),t(we,Vi),m(e,on,l),v(Ye,e,l),m(e,rn,l),m(e,wt,l),t(wt,Oi),m(e,ln,l),m(e,K,l),t(K,ge),t(ge,Hs),v(We,Hs,null),t(K,Bi),t(K,Vs),t(Vs,Li),m(e,pn,l),m(e,gt,l),t(gt,Xi),m(e,fn,l),m(e,I,l),t(I,Yi),t(I,$t),t($t,Wi),t(I,Ki),t(I,Et),t(Et,Qi),t(I,Ji),m(e,mn,l),m(e,$e,l),t($e,Zi),t($e,jt),t(jt,er),t($e,tr),m(e,hn,l),v(Ke,e,l),m(e,cn,l),m(e,kt,l),t(kt,sr),m(e,un,l),m(e,Tt,l),m(e,dn,l),m(e,Q,l),t(Q,Ee),t(Ee,Os),v(Qe,Os,null),t(Q,ar),t(Q,Bs),t(Bs,nr),m(e,_n,l),m(e,Pt,l),t(Pt,or),m(e,vn,l),m(e,je,l),t(je,ir),t(je,Dt),t(Dt,rr),t(je,lr),m(e,yn,l),v(Je,e,l),m(e,bn,l),m(e,At,l),t(At,pr),m(e,wn,l),m(e,ke,l),t(ke,fr),t(ke,Ls),t(Ls,mr),t(ke,hr),m(e,gn,l),v(Te,e,l),m(e,$n,l),m(e,St,l),t(St,cr),m(e,En,l),v(Ze,e,l),m(e,jn,l),m(e,D,l),t(D,Xs),t(Xs,ur),t(D,dr),t(D,Ys),t(Ys,_r),t(D,vr),t(D,Ws),t(Ws,yr),t(D,br),t(D,et),t(et,wr),t(D,gr),m(e,kn,l),m(e,qt,l),m(e,Tn,l),m(e,J,l),t(J,Pe),t(Pe,Ks),v(tt,Ks,null),t(J,$r),t(J,Qs),t(Qs,Er),m(e,Pn,l),m(e,st,l),t(st,Nt),t(Nt,jr),t(st,kr),m(e,Dn,l),m(e,C,l),t(C,Tr),t(C,Js),t(Js,Pr),t(C,Dr),t(C,Zs),t(Zs,Ar),t(C,Sr),m(e,An,l),m(e,xt,l),t(xt,qr),m(e,Sn,l),m(e,De,l),t(De,Nr),t(De,ea),t(ea,xr),t(De,Ur),m(e,qn,l),v(at,e,l),m(e,Nn,l),m(e,Ut,l),t(Ut,Ir),m(e,xn,l),v(nt,e,l),m(e,Un,l),v(Ae,e,l),m(e,In,l),m(e,Z,l),t(Z,Se),t(Se,ta),v(ot,ta,null),t(Z,Cr),t(Z,sa),t(sa,Fr),m(e,Cn,l),m(e,It,l),t(It,Gr),m(e,Fn,l),m(e,Ct,l),t(Ct,Rr),m(e,Gn,l),v(it,e,l),m(e,Rn,l),m(e,ee,l),t(ee,qe),t(qe,aa),v(rt,aa,null),t(ee,zr),t(ee,na),t(na,Mr),m(e,zn,l),m(e,Ne,l),t(Ne,Hr),t(Ne,oa),t(oa,Vr),t(Ne,Or),m(e,Mn,l),m(e,Ft,l),t(Ft,Br),m(e,Hn,l),v(lt,e,l),m(e,Vn,l),m(e,xe,l),t(xe,Lr),t(xe,ia),t(ia,Xr),t(xe,Yr),m(e,On,l),v(pt,e,l),m(e,Bn,l),m(e,te,l),t(te,Ue),t(Ue,ra),v(ft,ra,null),t(te,Wr),t(te,la),t(la,Kr),m(e,Ln,l),m(e,F,l),t(F,Qr),t(F,mt),t(mt,Jr),t(F,Zr),t(F,ht),t(ht,el),t(F,tl),m(e,Xn,l),m(e,Gt,l),t(Gt,sl),m(e,Yn,l),m(e,Ie,l),t(Ie,pa),t(pa,se),t(se,fa),t(fa,al),t(se,nl),t(se,ma),t(ma,ol),t(se,il),t(se,ha),t(ha,rl),t(Ie,ll),t(Ie,E),t(E,ae),t(ae,ca),t(ca,pl),t(ae,fl),t(ae,ua),t(ua,ml),t(ae,hl),t(ae,da),t(da,cl),t(E,ul),t(E,ne),t(ne,_a),t(_a,dl),t(ne,_l),t(ne,va),t(va,vl),t(ne,yl),t(ne,ya),t(ya,bl),t(E,wl),t(E,oe),t(oe,ba),t(ba,gl),t(oe,$l),t(oe,wa),t(wa,El),t(oe,jl),t(oe,ga),t(ga,kl),t(E,Tl),t(E,ie),t(ie,$a),t($a,Pl),t(ie,Dl),t(ie,Ea),t(Ea,Al),t(ie,Sl),t(ie,ja),t(ja,ql),t(E,Nl),t(E,re),t(re,ka),t(ka,xl),t(re,Ul),t(re,Ta),t(Ta,Il),t(re,Cl),t(re,Pa),t(Pa,Fl),t(E,Gl),t(E,le),t(le,Da),t(Da,Rl),t(le,zl),t(le,Aa),t(Aa,Ml),t(le,Hl),t(le,Sa),t(Sa,Vl),t(E,Ol),t(E,pe),t(pe,qa),t(qa,Bl),t(pe,Ll),t(pe,Na),t(Na,Xl),t(pe,Yl),t(pe,xa),t(xa,Wl),m(e,Wn,l),m(e,Rt,l),t(Rt,Kl),m(e,Kn,l),m(e,G,l),t(G,Ua),t(Ua,Ql),t(G,Jl),t(G,Ia),t(Ia,Zl),t(G,ep),t(G,zt),t(zt,Mt),t(Mt,tp),t(zt,sp),m(e,Qn,l),v(ct,e,l),Jn=!0},p(e,[l]){const ut={};l&2&&(ut.$$scope={dirty:l,ctx:e}),ve.$set(ut);const Ca={};l&2&&(Ca.$$scope={dirty:l,ctx:e}),be.$set(Ca);const Fa={};l&2&&(Fa.$$scope={dirty:l,ctx:e}),Te.$set(Fa);const Ga={};l&2&&(Ga.$$scope={dirty:l,ctx:e}),Ae.$set(Ga)},i(e){Jn||(y(k.$$.fragment,e),y(Ge.$$.fragment,e),y(Me.$$.fragment,e),y(He.$$.fragment,e),y(Oe.$$.fragment,e),y(Be.$$.fragment,e),y(Le.$$.fragment,e),y(ve.$$.fragment,e),y(Xe.$$.fragment,e),y(be.$$.fragment,e),y(Ye.$$.fragment,e),y(We.$$.fragment,e),y(Ke.$$.fragment,e),y(Qe.$$.fragment,e),y(Je.$$.fragment,e),y(Te.$$.fragment,e),y(Ze.$$.fragment,e),y(tt.$$.fragment,e),y(at.$$.fragment,e),y(nt.$$.fragment,e),y(Ae.$$.fragment,e),y(ot.$$.fragment,e),y(it.$$.fragment,e),y(rt.$$.fragment,e),y(lt.$$.fragment,e),y(pt.$$.fragment,e),y(ft.$$.fragment,e),y(ct.$$.fragment,e),Jn=!0)},o(e){b(k.$$.fragment,e),b(Ge.$$.fragment,e),b(Me.$$.fragment,e),b(He.$$.fragment,e),b(Oe.$$.fragment,e),b(Be.$$.fragment,e),b(Le.$$.fragment,e),b(ve.$$.fragment,e),b(Xe.$$.fragment,e),b(be.$$.fragment,e),b(Ye.$$.fragment,e),b(We.$$.fragment,e),b(Ke.$$.fragment,e),b(Qe.$$.fragment,e),b(Je.$$.fragment,e),b(Te.$$.fragment,e),b(Ze.$$.fragment,e),b(tt.$$.fragment,e),b(at.$$.fragment,e),b(nt.$$.fragment,e),b(Ae.$$.fragment,e),b(ot.$$.fragment,e),b(it.$$.fragment,e),b(rt.$$.fragment,e),b(lt.$$.fragment,e),b(pt.$$.fragment,e),b(ft.$$.fragment,e),b(ct.$$.fragment,e),Jn=!1},d(e){s(u),e&&s(c),e&&s(g),w(k),e&&s(Ra),e&&s(S),e&&s(za),e&&s(_t),e&&s(Ma),e&&s(me),e&&s(Va),e&&s(vt),e&&s(Oa),e&&s(L),w(Ge),e&&s(Ba),e&&s(Re),e&&s(La),e&&s(ce),e&&s(Xa),w(Me,e),e&&s(Ya),e&&s(X),w(He),e&&s(Wa),e&&s(de),e&&s(Ka),w(Oe,e),e&&s(Qa),e&&s(Y),w(Be),e&&s(Ja),e&&s(U),e&&s(Za),w(Le,e),e&&s(en),w(ve,e),e&&s(tn),e&&s(W),w(Xe),e&&s(sn),e&&s(yt),e&&s(an),w(be,e),e&&s(nn),e&&s(we),e&&s(on),w(Ye,e),e&&s(rn),e&&s(wt),e&&s(ln),e&&s(K),w(We),e&&s(pn),e&&s(gt),e&&s(fn),e&&s(I),e&&s(mn),e&&s($e),e&&s(hn),w(Ke,e),e&&s(cn),e&&s(kt),e&&s(un),e&&s(Tt),e&&s(dn),e&&s(Q),w(Qe),e&&s(_n),e&&s(Pt),e&&s(vn),e&&s(je),e&&s(yn),w(Je,e),e&&s(bn),e&&s(At),e&&s(wn),e&&s(ke),e&&s(gn),w(Te,e),e&&s($n),e&&s(St),e&&s(En),w(Ze,e),e&&s(jn),e&&s(D),e&&s(kn),e&&s(qt),e&&s(Tn),e&&s(J),w(tt),e&&s(Pn),e&&s(st),e&&s(Dn),e&&s(C),e&&s(An),e&&s(xt),e&&s(Sn),e&&s(De),e&&s(qn),w(at,e),e&&s(Nn),e&&s(Ut),e&&s(xn),w(nt,e),e&&s(Un),w(Ae,e),e&&s(In),e&&s(Z),w(ot),e&&s(Cn),e&&s(It),e&&s(Fn),e&&s(Ct),e&&s(Gn),w(it,e),e&&s(Rn),e&&s(ee),w(rt),e&&s(zn),e&&s(Ne),e&&s(Mn),e&&s(Ft),e&&s(Hn),w(lt,e),e&&s(Vn),e&&s(xe),e&&s(On),w(pt,e),e&&s(Bn),e&&s(te),w(ft),e&&s(Ln),e&&s(F),e&&s(Xn),e&&s(Gt),e&&s(Yn),e&&s(Ie),e&&s(Wn),e&&s(Rt),e&&s(Kn),e&&s(G),e&&s(Qn),w(ct,e)}}}const Sm={local:"memory-and-speed",sections:[{local:"enable-cudnn-autotuner",sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:"Enable cuDNN auto-tuner"},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"model-offloading-for-fast-inference-and-memory-savings",title:"Model offloading for fast inference and memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function qm(x){return jm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Cm extends wm{constructor(u){super();gm(this,u,qm,Am,$m,{})}}export{Cm as default,Sm as metadata};
